Index: drivers/scsi/qla1280.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/scsi/qla1280.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/scsi/qla1280.c	22 Jul 2004 19:50:06 -0000	1.1
+++ drivers/scsi/qla1280.c	4 Aug 2004 01:29:36 -0000	1.2
@@ -4888,832 +4253,313 @@
  *      ha           = adapter block pointer.
  *      done_q_first = done queue first pointer.
  *      done_q_last  = done queue last pointer.
- *      INTR_LOCK must be already obtained.
  ****************************************************************************/
-STATIC void
-qla1280_isr(scsi_qla_host_t *ha, srb_t **done_q_first, srb_t **done_q_last)
-{
-    device_reg_t    *reg = ha->iobase;
-    response_t      *pkt;
-    srb_t           *sp;
-    uint16_t        mailbox[MAILBOX_REGISTER_COUNT];
-    uint16_t        *wptr;
-    uint32_t        index;
-
-    ENTER("qla1280_isr");
-
-
-    /* Save mailbox register 5 */
-    mailbox[5] = RD_REG_WORD(&reg->mailbox5);
-
-    /* Check for mailbox interrupt. */
-
-    mailbox[0] = RD_REG_WORD(&reg->semaphore);
-    if (mailbox[0] & BIT_0)
-    {
-        /* Get mailbox data. */
-
-        wptr = &mailbox[0];
-        *wptr++ = RD_REG_WORD(&reg->mailbox0);
-        *wptr++ = RD_REG_WORD(&reg->mailbox1);
-        *wptr = RD_REG_WORD(&reg->mailbox2);
-        if (mailbox[0] != MBA_SCSI_COMPLETION)
-        {
-            wptr++;
-            *wptr++ = RD_REG_WORD(&reg->mailbox3);
-            *wptr++ = RD_REG_WORD(&reg->mailbox4);
-            wptr++;
-            *wptr++ = RD_REG_WORD(&reg->mailbox6);
-            *wptr   = RD_REG_WORD(&reg->mailbox7);
-        }
-
-        /* Release mailbox registers. */
-
-        WRT_REG_WORD(&reg->semaphore, 0);
-        WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
-
-#ifdef QL_DEBUG_LEVEL_5
-        qla1280_print("qla1280_isr: mailbox interrupt mailbox[0] = ");
-        qla1280_output_number((uint32_t)mailbox[0], 16);
-        qla1280_print("\n\r");
-#endif
-
-        /* Handle asynchronous event */
-
-        switch (mailbox[0])
-        {
-            case MBA_SCSI_COMPLETION:   /* Response completion */
-#ifdef QL_DEBUG_LEVEL_5
-                qla1280_print("qla1280_isr: mailbox response completion\n\r");
-#endif
-                if (ha->flags.online)
-                {
-                    /* Get outstanding command index. */
-                    index = (uint32_t)(mailbox[2] << 16 | mailbox[1]);
-
-                    /* Validate handle. */
-                    if (index < MAX_OUTSTANDING_COMMANDS)
-                        sp = ha->outstanding_cmds[index];
-                    else
-                        sp = 0;
-
-                    if (sp)
-                    {
-                        /* Free outstanding command slot. */
-                        ha->outstanding_cmds[index] = 0;
-
-                        /* Save ISP completion status */
-                        CMD_RESULT(sp->cmd) = 0;
-
-                        /* Place block on done queue */
-                        sp->s_next = NULL;
-                        sp->s_prev = *done_q_last;
-                        if (!*done_q_first)
-                            *done_q_first = sp;
-                        else
-                            (*done_q_last)->s_next = sp;
-                        *done_q_last = sp;
-                    }
-                    else
-                    {
-#ifdef QL_DEBUG_LEVEL_2
-                            qla1280_print("qla1280_isr: ISP invalid handle\n\r");
-#endif
-                            printk(KERN_WARNING "qla1280: ISP invalid handle");
-                            ha->flags.isp_abort_needed = TRUE;
-                    }
-                }
-                break;
-            case MBA_BUS_RESET:         /* SCSI Bus Reset */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: asynchronous BUS_RESET\n\r");
-#endif
-                ha->flags.reset_marker = TRUE;
-                index = mailbox[6] & BIT_0;
-                ha->bus_settings[index].reset_marker = TRUE;
-                break;
-            case MBA_SYSTEM_ERR:        /* System Error */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: ISP System Error - mbx1=");
-                qla1280_output_number((uint32_t)mailbox[1], 16);
-                qla1280_print(", mbx2=");
-                qla1280_output_number((uint32_t)mailbox[2], 16);
-                qla1280_print(", mbx3=");
-                qla1280_output_number((uint32_t)mailbox[3], 16);
-                qla1280_print("\n\r");
-#endif
-                printk(KERN_WARNING
-                        "qla1280: ISP System Error - mbx1=%xh, mbx2=%xh, mbx3=%xh\n",
-                        mailbox[1], mailbox[2], mailbox[3]);
-                ha->flags.isp_abort_needed = TRUE;
-                break;
-            case MBA_REQ_TRANSFER_ERR:  /* Request Transfer Error */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: ISP Request Transfer Error\n\r");
-#endif
-                printk(KERN_WARNING "qla1280: ISP Request Transfer Error\n");
-                ha->flags.isp_abort_needed = TRUE;
-                break;
-            case MBA_RSP_TRANSFER_ERR:  /* Response Transfer Error */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: ISP Response Transfer Error\n\r");
-#endif
-                printk(KERN_WARNING "qla1280: ISP Response Transfer Error\n");
-                ha->flags.isp_abort_needed = TRUE;
-                break;
-            case MBA_WAKEUP_THRES:      /* Request Queue Wake-up */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: asynchronous WAKEUP_THRES\n\r");
-#endif
-                break;
-            case MBA_TIMEOUT_RESET:     /* Execution Timeout Reset */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print("qla1280_isr: asynchronous TIMEOUT_RESET\n\r");
-#endif
-                break;
-            case MBA_DEVICE_RESET:         /* Bus Device Reset */
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print(
-                        "qla1280_isr: asynchronous BUS_DEVICE_RESET\n\r");
-#endif
-                ha->flags.reset_marker = TRUE;
-                index = mailbox[6] & BIT_0;
-                ha->bus_settings[index].reset_marker = TRUE;
-                break;
-            case MBA_BUS_MODE_CHANGE:
-#ifdef QL_DEBUG_LEVEL_2
-                qla1280_print(
-                        "qla1280_isr: asynchronous BUS_MODE_CHANGE\n\r");
-#endif
-                break;
-            default:
-                if (mailbox[0] < MBA_ASYNC_EVENT)
-                {
-                        wptr = &mailbox[0];
-                        ha->mailbox_out[0] = *wptr++;
-                        ha->mailbox_out[1] = *wptr++;
-                        ha->mailbox_out[2] = *wptr++;
-                        ha->mailbox_out[3] = *wptr++;
-                        ha->mailbox_out[4] = *wptr++;
-                        ha->mailbox_out[5] = *wptr++;
-                        ha->mailbox_out[6] = *wptr++;
-                        ha->mailbox_out[7] = *wptr;
-                        ha->flags.mbox_int = TRUE;
-                }
-                break;
-        }
-    }
-    else
-        WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
-
-    /*
-    * Response ring
-    */
-    if (ha->flags.online && !ha->flags.mbox_busy)
-    {
-        if (mailbox[5] < RESPONSE_ENTRY_CNT)
-        {
-            while (ha->rsp_ring_index != mailbox[5])
-            {
-                pkt = ha->response_ring_ptr;
-
-#ifdef QL_DEBUG_LEVEL_5
-                qla1280_print("qla1280_isr: ha->rsp_ring_index = ");
-                qla1280_output_number((uint32_t)ha->rsp_ring_index, 16);
-                qla1280_print(" mailbox[5] = ");
-                qla1280_output_number((uint32_t)mailbox[5], 16);
-                qla1280_print("\n\rqla1280_isr: response packet data\n\r");
-                qla1280_dump_buffer((caddr_t)pkt, RESPONSE_ENTRY_SIZE);
-#endif
-
-#if defined(QL_DEBUG_LEVEL_2) && !defined(QL_DEBUG_LEVEL_5)
-                if (pkt->entry_type == STATUS_TYPE)
-                {
-                    if ((uint8_t)(pkt->scsi_status) || pkt->comp_status ||
-                        pkt->entry_status)
-                    {
-                        DEBUG(qla1280_print("qla1280_isr: ha->rsp_ring_index = ");)
-                        DEBUG(qla1280_output_number((uint32_t)ha->rsp_ring_index,
-                                16);)
-                        DEBUG(qla1280_print(" mailbox[5] = ");)
-                        DEBUG(qla1280_output_number((uint32_t)mailbox[5], 16);)
-                        DEBUG(qla1280_print( "\n\r comp_status = ");)
-                        DEBUG(qla1280_output_number((uint32_t)pkt->comp_status,16);)
-                        DEBUG(qla1280_print( ", ");)
-                        DEBUG(qla1280_print( " scsi_status = ");)
-                        DEBUG(qla1280_output_number((uint32_t)pkt->scsi_status,16);)
-                        DEBUG(qla1280_print( "\n\r");)
-                        /* qla1280_print(
-                        "\n\rqla1280_isr: response packet data\n\r");
-                        qla1280_dump_buffer((caddr_t)pkt,
-                        RESPONSE_ENTRY_SIZE); */
-                    }
-                }
-                else
-                {
-                    qla1280_print("qla1280_isr: ha->rsp_ring_index = ");
-                    qla1280_output_number((uint32_t)ha->rsp_ring_index, 16);
-                    qla1280_print(" mailbox[5] = ");
-                    qla1280_output_number((uint32_t)mailbox[5], 16);
-                    qla1280_print(
-                            "\n\rqla1280_isr: response packet data\n\r");
-                    qla1280_dump_buffer((caddr_t)pkt, RESPONSE_ENTRY_SIZE);
-                }
-#endif
-                if (pkt->entry_type == STATUS_TYPE || pkt->entry_status)
-                {
-                    if (pkt->entry_type == STATUS_TYPE)
-                        qla1280_status_entry(ha, (sts_entry_t *)pkt,
-                                done_q_first, done_q_last);
-                    else
-                        qla1280_error_entry(ha, pkt,
-                                done_q_first, done_q_last);
-
-                    /* Adjust ring index. */
-                    ha->rsp_ring_index++;
-                    if (ha->rsp_ring_index == RESPONSE_ENTRY_CNT)
-                    {
-                        ha->rsp_ring_index = 0;
-                        ha->response_ring_ptr = ha->response_ring;
-                    }
-                    else
-                        ha->response_ring_ptr++;
-                    WRT_REG_WORD(&reg->mailbox5, ha->rsp_ring_index);
-                }
-#if QLA1280_TARGET_MODE_SUPPORT
-                else
-                {
-                    pkt = &response_entry;
-
-                    /* Copy packet. */
-                    dptr1 = (uint32_t *)ha->response_ring_ptr;
-                    dptr2 = (uint32_t *)pkt;
-                    for (index = 0; index < RESPONSE_ENTRY_SIZE/4; index++)
-                        *dptr2++ = *dptr1++;
-
-                    /* Adjust ring index. */
-                    ha->rsp_ring_index++;
-                    if (ha->rsp_ring_index == RESPONSE_ENTRY_CNT)
-                    {
-                        ha->rsp_ring_index = 0;
-                        ha->response_ring_ptr = ha->response_ring;
-                    }
-                    else
-                        ha->response_ring_ptr++;
-                    WRT_REG_WORD(&reg->mailbox5, ha->rsp_ring_index);
-
-                    /* Release interrupt specific lock */
-                    QLA1280_INTR_UNLOCK(ha);
-
-                    switch (pkt->entry_type)
-                    {
-                        case ACCEPT_TGT_IO_TYPE:
-                            qla1280_atio_entry(ha, (atio_entry_t *)pkt);
-                            break;
-                        case IMMED_NOTIFY_TYPE:
-                            qla1280_notify_entry(ha, (notify_entry_t *)pkt);
-                            break;
-                        case CTIO_RET_TYPE:
-                            qla1280_accept_io(ha, (ctio_ret_entry_t *)pkt);
-                            break;
-                        default:
-                            break;
-                    }
-
-                    /* Acquire interrupt specific lock */
-                    QLA1280_INTR_LOCK(ha);
-                }
-#endif
-            }
-        }
-        else
-        {
-            ha->flags.isp_abort_needed = TRUE;
-#ifdef QL_DEBUG_LEVEL_2
-            qla1280_print("qla1280_isr: Response pointer Error\n");
-#endif
-        }
-    }
+static void
+qla1280_isr(struct scsi_qla_host *ha, struct srb ** done_q_first,
+	    struct srb ** done_q_last)
+{
+	struct device_reg *reg = ha->iobase;
+	struct response *pkt;
+	struct srb *sp = 0;
+	uint16_t mailbox[MAILBOX_REGISTER_COUNT];
+	uint16_t *wptr;
+	uint32_t index;
+	u16 istatus;
+
+	ENTER("qla1280_isr");
+
+	istatus = RD_REG_WORD(&reg->istatus);
+	if (!(istatus & (RISC_INT | PCI_INT)))
+		return;
+
+	/* Save mailbox register 5 */
+	mailbox[5] = RD_REG_WORD(&reg->mailbox5);
+
+	/* Check for mailbox interrupt. */
+
+	mailbox[0] = RD_REG_WORD(&reg->semaphore);
+
+	if (mailbox[0] & BIT_0) {
+		/* Get mailbox data. */
+		/* dprintk(1, "qla1280_isr: In Get mailbox data \n"); */
+
+		wptr = &mailbox[0];
+		*wptr++ = RD_REG_WORD(&reg->mailbox0);
+		*wptr++ = RD_REG_WORD(&reg->mailbox1);
+		*wptr = RD_REG_WORD(&reg->mailbox2);
+		if (mailbox[0] != MBA_SCSI_COMPLETION) {
+			wptr++;
+			*wptr++ = RD_REG_WORD(&reg->mailbox3);
+			*wptr++ = RD_REG_WORD(&reg->mailbox4);
+			wptr++;
+			*wptr++ = RD_REG_WORD(&reg->mailbox6);
+			*wptr = RD_REG_WORD(&reg->mailbox7);
+		}
 
-    LEAVE("qla1280_isr");
-}
+		/* Release mailbox registers. */
 
-/*
- *  qla1280_rst_aen
- *      Processes asynchronous reset.
- *
- * Input:
- *      ha  = adapter block pointer.
- */
-STATIC void
-qla1280_rst_aen(scsi_qla_host_t *ha)
-{
-#if QL1280_TARGET_MODE_SUPPORT
-    notify_entry_t  nentry;
-#endif
-    uint8_t         b;
+		WRT_REG_WORD(&reg->semaphore, 0);
+		WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
+
+		dprintk(5, "qla1280_isr: mailbox interrupt mailbox[0] = 0x%x",
+			mailbox[0]);
+
+		/* Handle asynchronous event */
+		switch (mailbox[0]) {
+		case MBA_SCSI_COMPLETION:	/* Response completion */
+			dprintk(5, "qla1280_isr: mailbox SCSI response "
+				"completion\n");
+
+			if (ha->flags.online) {
+				/* Get outstanding command index. */
+				index = mailbox[2] << 16 | mailbox[1];
+
+				/* Validate handle. */
+				if (index < MAX_OUTSTANDING_COMMANDS)
+					sp = ha->outstanding_cmds[index];
+				else
+					sp = 0;
+
+				if (sp) {
+					/* Free outstanding command slot. */
+					ha->outstanding_cmds[index] = 0;
+
+					/* Save ISP completion status */
+					CMD_RESULT(sp->cmd) = 0;
+
+					/* Place block on done queue */
+					sp->s_next = NULL;
+					sp->s_prev = *done_q_last;
+					if (!*done_q_first)
+						*done_q_first = sp;
+					else
+						(*done_q_last)->s_next = sp;
+					*done_q_last = sp;
+				} else {
+					/*
+					 * If we get here we have a real problem!
+					 */
+					printk(KERN_WARNING
+					       "qla1280: ISP invalid handle");
+				}
+			}
+			break;
+
+		case MBA_BUS_RESET:	/* SCSI Bus Reset */
+			ha->flags.reset_marker = 1;
+			index = mailbox[6] & BIT_0;
+			ha->bus_settings[index].reset_marker = 1;
+
+			printk(KERN_DEBUG "qla1280_isr(): index %i "
+			       "asynchronous BUS_RESET\n", index);
+			break;
+
+		case MBA_SYSTEM_ERR:	/* System Error */
+			printk(KERN_WARNING
+			       "qla1280: ISP System Error - mbx1=%xh, mbx2="
+			       "%xh, mbx3=%xh\n", mailbox[1], mailbox[2],
+			       mailbox[3]);
+			break;
+
+		case MBA_REQ_TRANSFER_ERR:	/* Request Transfer Error */
+			printk(KERN_WARNING
+			       "qla1280: ISP Request Transfer Error\n");
+			break;
+
+		case MBA_RSP_TRANSFER_ERR:	/* Response Transfer Error */
+			printk(KERN_WARNING
+			       "qla1280: ISP Response Transfer Error\n");
+			break;
+
+		case MBA_WAKEUP_THRES:	/* Request Queue Wake-up */
+			dprintk(2, "qla1280_isr: asynchronous WAKEUP_THRES\n");
+			break;
+
+		case MBA_TIMEOUT_RESET:	/* Execution Timeout Reset */
+			dprintk(2,
+				"qla1280_isr: asynchronous TIMEOUT_RESET\n");
+			break;
+
+		case MBA_DEVICE_RESET:	/* Bus Device Reset */
+			printk(KERN_INFO "qla1280_isr(): asynchronous "
+			       "BUS_DEVICE_RESET\n");
+
+			ha->flags.reset_marker = 1;
+			index = mailbox[6] & BIT_0;
+			ha->bus_settings[index].reset_marker = 1;
+			break;
+
+		case MBA_BUS_MODE_CHANGE:
+			dprintk(2,
+				"qla1280_isr: asynchronous BUS_MODE_CHANGE\n");
+			break;
+
+		default:
+			/* dprintk(1, "qla1280_isr: default case of switch MB \n"); */
+			if (mailbox[0] < MBA_ASYNC_EVENT) {
+				wptr = &mailbox[0];
+				memcpy((uint16_t *) ha->mailbox_out, wptr,
+				       MAILBOX_REGISTER_COUNT *
+				       sizeof(uint16_t));
+
+				if(ha->mailbox_wait != NULL)
+					complete(ha->mailbox_wait);
+			}
+			break;
+		}
+	} else {
+		WRT_REG_WORD(&reg->host_cmd, HC_CLR_RISC_INT);
+	}
 
-#ifdef QL_DEBUG_LEVEL_3
-    ENTER("qla1280_rst_aen");
+	/*
+	 * Response ring - waiting for the mbox_busy flag here seems
+	 * unnecessary as the mailbox data has been copied to ha->mailbox_out
+	 * by the time we actually get here!
+	 */
+	if (!(ha->flags.online
+#if 0
+	    && !ha->flags.mbox_busy
 #endif
+		)) {
+		dprintk(2, "qla1280_isr: Response pointer Error\n");
+		goto out;
+	}
 
-    if (ha->flags.online && !ha->flags.reset_active &&
-        !ha->flags.abort_isp_active)
-    {
-        ha->flags.reset_active = TRUE;
-        while (ha->flags.reset_marker)
-        {
-            /* Issue marker command. */
-            ha->flags.reset_marker = FALSE;
-            for (b = 0; b < ha->ports && !ha->flags.reset_marker; b++)
-            {
-                if (ha->bus_settings[b].reset_marker)
-                {
-                    ha->bus_settings[b].reset_marker = FALSE;
-                    qla1280_marker(ha, b, 0, 0, MK_SYNC_ALL);
+	if (mailbox[5] >= RESPONSE_ENTRY_CNT)
+		goto out;
 
-                    if (!ha->flags.reset_marker)
-                    {
-#if QL1280_TARGET_MODE_SUPPORT
-                        /* Issue notify acknowledgement command. */
-                        bzero((caddr_t)&nentry, sizeof(notify_entry_t));
+	while (ha->rsp_ring_index != mailbox[5]) {
+		pkt = ha->response_ring_ptr;
 
-                        nentry.initiator_id = nentry.target_id = b ?
-                                ha->bus_settings[b].id | BIT_7 :
-                        ha->bus_settings[b].id;
-                        qla1280_notify_entry(ha, &nentry);
-#endif
+		dprintk(5, "qla1280_isr: ha->rsp_ring_index = 0x%x, mailbox[5]"
+			" = 0x%x\n", ha->rsp_ring_index, mailbox[5]);
+		dprintk(5,"qla1280_isr: response packet data\n");
+		qla1280_dump_buffer(5, (char *)pkt, RESPONSE_ENTRY_SIZE);
+
+		if (pkt->entry_type == STATUS_TYPE) {
+			if ((le16_to_cpu(pkt->scsi_status) & 0xff)
+			    || pkt->comp_status || pkt->entry_status) {
+				dprintk(2, "qla1280_isr: ha->rsp_ring_index = "
+					"0x%x mailbox[5] = 0x%x, comp_status "
+					"= 0x%x, scsi_status = 0x%x\n",
+					ha->rsp_ring_index, mailbox[5],
+					le16_to_cpu(pkt->comp_status),
+					le16_to_cpu(pkt->scsi_status));
+			}
+		} else {
+			dprintk(2, "qla1280_isr: ha->rsp_ring_index = "
+				"0x%x, mailbox[5] = 0x%x\n",
+				ha->rsp_ring_index, mailbox[5]);
+			dprintk(2, "qla1280_isr: response packet data\n");
+			qla1280_dump_buffer(2, (char *)pkt,
+					    RESPONSE_ENTRY_SIZE);
+		}
 
-                        /* Asynchronous event notification */
-                    }
-                }
-            }
-        }
-    }
+		if (pkt->entry_type == STATUS_TYPE || pkt->entry_status) {
+			dprintk(2, "status: Cmd %p, handle %i\n",
+				ha->outstanding_cmds[pkt->handle]->cmd,
+				pkt->handle);
+			if (pkt->entry_type == STATUS_TYPE)
+				qla1280_status_entry(ha, pkt, done_q_first,
+						     done_q_last);
+			else
+				qla1280_error_entry(ha, pkt, done_q_first,
+						    done_q_last);
 
-#ifdef QL_DEBUG_LEVEL_3
-    LEAVE("qla1280_rst_aen");
-#endif
+			/* Adjust ring index. */
+			ha->rsp_ring_index++;
+			if (ha->rsp_ring_index == RESPONSE_ENTRY_CNT) {
+				ha->rsp_ring_index = 0;
+				ha->response_ring_ptr =	ha->response_ring;
+			} else
+				ha->response_ring_ptr++;
+			WRT_REG_WORD(&reg->mailbox5, ha->rsp_ring_index);
+		}
+	}
+	
+ out:
+	LEAVE("qla1280_isr");
 }
 
-#if QL1280_TARGET_MODE_SUPPORT
 /*
- *  qla1280_atio_entry
- *      Processes received ISP accept target I/O entry.
+ *  qla1280_rst_aen
+ *      Processes asynchronous reset.
  *
  * Input:
  *      ha  = adapter block pointer.
- *      pkt = entry pointer.
  */
-STATIC void
-qla1280_atio_entry(scsi_qla_host_t *ha, atio_entry_t *pkt)
+static void
+qla1280_rst_aen(struct scsi_qla_host *ha)
 {
-    uint64_t    *a64;
-    uint64_t    *end_a64;
-    paddr32_t   phy_addr[2];
-    paddr32_t   end_addr[2];
-    uint32_t    len;
-    uint32_t    offset;
-    uint8_t     t;
-    uint8_t     *sense_ptr;
-
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_atio_entry: entered\n\r");
-#endif
-
-    t = pkt->initiator_id;
-    sense_ptr = ha->tsense + t * TARGET_SENSE_SIZE;
-    a64 = (uint64_t *)&phy_addr[0];
-    end_a64 = (uint64_t *)&end_addr[0];
-
-    switch (pkt->status & ~BIT_7)
-    {
-        case 7:                         /* Path invalid */
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-            qla1280_print("qla1280_atio_entry: Path invalid\n\r");
-#endif
-            break;
-        case 0x14:                  /* Target Bus Phase Sequence Failure */
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-            qla1280_print(
-                    "qla1280_atio_entry: Target Bus Phase Sequence Failure\n\r");
-#endif
-            if (pkt->status & BIT_7)
-            {
-                BCOPY((caddr_t)&pkt->sense_data, sense_ptr,TARGET_SENSE_SIZE);
-            }
-            else
-            {
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    *sense_ptr = 0x70;
-                    *(sense_ptr+2) = SD_HARDERR;
-                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                    *(sense_ptr+12) = SC_SELFAIL;
-            }
-            pkt->scsi_status = S_CKCON;
-            pkt->option_flags |= (uint32_t)OF_SSTS | (uint32_t)OF_NO_DATA;
-            if (ha->flags.enable_64bit_addressing)
-                qla1280_64bit_continue_io(ha, pkt, 0, 0);
-            else
-                qla1280_32bit_continue_io(ha, pkt, 0, 0);
-            break;
-        case 0x16:                  /* Requested Capability Not Available */
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-            qla1280_print(
-                    "qla1280_atio_entry: Target Bus Phase Sequence Failure\n\r");
-#endif
-            break;
-        case 0x17:                  /* Bus Device Reset Message Received */
-#if defined(QL_DEBUG_LEVEL_2) || defined(QL_DEBUG_LEVEL_3)
-            qla1280_print(
-                    "qla1280_atio_entry: Target Bus Phase Sequence Failure\n\r");
-#endif
-            break;
-        case 0x3D:                  /* CDB Received */
-
-            /* Check for invalid LUN */
-            if (pkt->lun && pkt->cdb[0] != SS_INQUIR &&
-                pkt->cdb[0] != SS_REQSEN)
-                pkt->cdb[0] = SS_TEST;
-
-            switch (pkt->cdb[0])
-            {
-                case SS_TEST:
-#ifdef QL_DEBUG_LEVEL_3
-                    qla1280_print("qla1280_atio_entry: SS_TEST\n\r");
-#endif
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    len = 0;
-                    if (pkt->lun == 0)
-                        pkt->scsi_status = S_GOOD;
-                    else
-                    {
-                        *sense_ptr = 0x70;
-                        *(sense_ptr+2) = SD_ILLREQ;
-                        *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                        *(sense_ptr+12) = SC_INVLUN;
-                        pkt->scsi_status = S_CKCON;
-                    }
-
-                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                            (uint32_t)OF_NO_DATA;
-                    break;
-                case SS_REQSEN:
-#ifdef QL_DEBUG_LEVEL_3
-                    qla1280_print("qla1280_atio_entry: SS_REQSEN\n\r");
-#endif
-                    phy_addr[0] = ha->tsense_dma;
-                    phy_addr[1] = 0;
-                    *a64 += t * TARGET_SENSE_SIZE;
-                    if (pkt->cdb[4] > TARGET_SENSE_SIZE)
-                        len = TARGET_SENSE_SIZE;
-                    else
-                        len = pkt->cdb[4];
-                    pkt->scsi_status = S_GOOD;
-                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                            (uint32_t)OF_DATA_IN;
-                    break;
-                case SS_INQUIR:
-#ifdef QL_DEBUG_LEVEL_3
-                    qla1280_print("qla1280_atio_entry: SS_INQUIR\n\r");
-#endif
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    phy_addr[0] = ha->tbuf_dma;
-                    phy_addr[1] = 0;
-                    *a64 += TARGET_INQ_OFFSET;
-
-                    if (pkt->lun == 0)
-                    {
-                            ha->tbuf->inq.id_type = ID_PROCESOR;
-                            ha->tbuf->inq.id_pqual = ID_QOK;
-                    }
-                    else
-                    {
-                            ha->tbuf->inq.id_type = ID_NODEV;
-                            ha->tbuf->inq.id_pqual = ID_QNOLU;
-                    }
-
-                    if (pkt->cdb[4] > sizeof(struct ident))
-                        len = sizeof(struct ident);
-                    else
-                        len = pkt->cdb[4];
-                    pkt->scsi_status = S_GOOD;
-                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                            (uint32_t)OF_DATA_IN;
-                    break;
-                case SM_WRDB:
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    offset = pkt->cdb[5];
-                    offset |= pkt->cdb[4] << 8;
-                    offset |= pkt->cdb[3] << 16;
-                    len = pkt->cdb[8];
-                    len |= pkt->cdb[7] << 8;
-                    len |= pkt->cdb[6] << 16;
-                    end_addr[0] = phy_addr[0] = ha->tbuf_dma;
-                    end_addr[1] = phy_addr[1] = 0;
-                    *end_a64 += TARGET_DATA_OFFSET + TARGET_DATA_SIZE;
-                    switch (pkt->cdb[1] & 7)
-                    {
-                        case RW_BUF_HDATA:
-#ifdef QL_DEBUG_LEVEL_3
-                            qla1280_print("qla1280_atio_entry: SM_WRDB, RW_BUF_HDATA\n\r");
-#endif
-                            if (len > TARGET_DATA_SIZE + 4)
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                qla1280_print("qla1280_atio_entry: SM_WRDB, length > buffer size\n\r");
-#endif
-                                *sense_ptr = 0x70;
-                                *(sense_ptr+2) = SD_ILLREQ;
-                                *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                                *(sense_ptr+12) = SC_ILLCDB;
-                                pkt->scsi_status = S_CKCON;
-                                pkt->option_flags |= (uint32_t)OF_SSTS |
-                                        (uint32_t)OF_NO_DATA;
-                                len = 0;
-                            }
-                            else if (len)
-                            {
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_DATA_OUT;
-#ifdef QL_DEBUG_LEVEL_3
-                                    qla1280_print("qla1280_atio_entry: Issuing SDI_TARMOD_WRCOMP\n\r");
-#endif
-                                    sdi_xaen(SDI_TARMOD_WRCOMP, ha->cntlr,
-                                            pkt->target_id, pkt->lun, 0, offset);
-                            }
-                            else
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_WRDB, zero length\n\r");
-#endif
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-
-                            break;
-                        case RW_BUF_DATA:
-#ifdef QL_DEBUG_LEVEL_3
-                            qla1280_print("qla1280_atio_entry: SM_WRDB, RW_BUF_DATA\n\r");
-#endif
-                            *a64 += offset + TARGET_DATA_OFFSET;
-                            if (pkt->cdb[2] != 0 || *a64 >= *end_a64 ||
-                                *a64 + len > *end_a64)
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_WRDB, RW_BUF_DATA BAD\n\r");
-                                    qla1280_print("buf_id=");
-                                    qla1280_output_number((uint32_t)pkt->cdb[2], 16);
-                                    qla1280_print(", offset=");
-                                    qla1280_output_number((uint32_t)offset, 16);
-                                    qla1280_print(", length=");
-                                    qla1280_output_number((uint32_t)len, 16);
-                                    qla1280_print("\n\r");
-#endif
-                                    *sense_ptr = 0x70;
-                                    *(sense_ptr+2) = SD_ILLREQ;
-                                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                                    *(sense_ptr+12) = SC_ILLCDB;
-                                    len = 0;
-                                    pkt->scsi_status = S_CKCON;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-                            else if (len)
-                            {
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_DATA_OUT;
-#ifdef QL_DEBUG_LEVEL_3
-                                    qla1280_print("qla1280_atio_entry: Issuing SDI_TARMOD_WRCOMP\n\r");
-#endif
-                                    sdi_xaen(SDI_TARMOD_WRCOMP, ha->cntlr,
-                                            pkt->target_id, pkt->lun, 0, offset);
-                            }
-                            else
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_WRDB, zero length\n\r");
-#endif
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-                            break;
-                        default:
-#ifdef QL_DEBUG_LEVEL_2
-                            qla1280_print("qla1280_atio_entry: SM_WRDB unknown mode\n\r");
-#endif
-                            *sense_ptr = 0x70;
-                            *(sense_ptr+2) = SD_ILLREQ;
-                            *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                            *(sense_ptr+12) = SC_ILLCDB;
-                            len = 0;
-                            pkt->scsi_status = S_CKCON;
-                            pkt->option_flags |= (uint32_t)OF_SSTS |
-                                    (uint32_t)OF_NO_DATA;
-                            break;
-                    }
-                    break;
-                case SM_RDDB:
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    offset = pkt->cdb[5];
-                    offset |= pkt->cdb[4] << 8;
-                    offset |= pkt->cdb[3] << 16;
-                    len = pkt->cdb[8];
-                    len |= pkt->cdb[7] << 8;
-                    len |= pkt->cdb[6] << 16;
-                    end_addr[0] = phy_addr[0] = ha->tbuf_dma;
-                    end_addr[1] = phy_addr[1] = 0;
-                    *end_a64 += TARGET_DATA_OFFSET + TARGET_DATA_SIZE;
-                    switch (pkt->cdb[1] & 7)
-                    {
-                        case RW_BUF_HDATA:
-#ifdef QL_DEBUG_LEVEL_3
-                            qla1280_print("qla1280_atio_entry: SM_RDDB, RW_BUF_HDATA\n\r");
-#endif
-                            if (len)
-                            {
-                                ha->tbuf->hdr[0] = 0;
-                                ha->tbuf->hdr[1] =
-                                        (uint8_t)(TARGET_DATA_SIZE >> 16);
-                                ha->tbuf->hdr[2] =
-                                        (uint8_t)(TARGET_DATA_SIZE >> 8);
-                                ha->tbuf->hdr[3] = (uint8_t)TARGET_DATA_SIZE;
-                                if (len > TARGET_DATA_SIZE + 4)
-                                    len = TARGET_DATA_SIZE + 4;
-                                pkt->scsi_status = S_GOOD;
-                                pkt->option_flags |= (uint32_t)OF_SSTS |
-                                        (uint32_t)OF_DATA_IN;
-                            }
-                            else
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_RDDB, zero length\n\r");
-#endif
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-                            break;
-                        case RW_BUF_DATA:
-#ifdef QL_DEBUG_LEVEL_3
-                            qla1280_print("qla1280_atio_entry: SM_RDDB, RW_BUF_DATA\n\r");
-#endif
-                            *a64 += offset + TARGET_DATA_OFFSET;
-                            if (pkt->cdb[2] != 0 || *a64 >= *end_a64)
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_RDDB, RW_BUF_DATA BAD\n\r");
-                                    qla1280_print("buf_id=");
-                                    qla1280_output_number((uint32_t)pkt->cdb[2], 16);
-                                    qla1280_print(", offset=");
-                                    qla1280_output_number((uint32_t)offset, 16);
-                                    qla1280_print("\n\r");
-#endif
-                                    *sense_ptr = 0x70;
-                                    *(sense_ptr+2) = SD_ILLREQ;
-                                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                                    *(sense_ptr+12) = SC_ILLCDB;
-                                    len = 0;
-                                    pkt->scsi_status = S_CKCON;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-                            else
-                            {
-                                    if (*a64 + len > *end_a64)
-                                        len = *end_a64 - *a64;
-                                    if (len)
-                                    {
-                                        pkt->scsi_status = S_GOOD;
-                                        pkt->option_flags |= (uint32_t)OF_SSTS |
-                                                (uint32_t)OF_DATA_IN;
-                                    }
-                                    else
-                                    {
-#ifdef QL_DEBUG_LEVEL_2
-                                            qla1280_print("qla1280_atio_entry: SM_RDDB, zero length\n\r");
-#endif
-                                            pkt->scsi_status = S_GOOD;
-                                            pkt->option_flags |= (uint32_t)OF_SSTS |
-                                                    (uint32_t)OF_NO_DATA;
-                                    }
-                            }
-                            break;
-                        case RW_BUF_DESC:
-#ifdef QL_DEBUG_LEVEL_3
-                            qla1280_print("qla1280_atio_entry: SM_RDDB, RW_BUF_DESC\n\r");
-#endif
-                            if (len)
-                            {
-                                    if (len > 4)
-                                        len = 4;
-
-                                    ha->tbuf->hdr[0] = 0;
-                                    if (pkt->cdb[2] != 0)
-                                    {
-                                        ha->tbuf->hdr[1] = 0;
-                                        ha->tbuf->hdr[2] = 0;
-                                        ha->tbuf->hdr[3] = 0;
-                                    }
-                                    else
-                                    {
-                                            ha->tbuf->hdr[1] =
-                                                    (uint8_t)(TARGET_DATA_SIZE >> 16);
-                                            ha->tbuf->hdr[2] =
-                                                    (uint8_t)(TARGET_DATA_SIZE >> 8);
-                                            ha->tbuf->hdr[3] =
-                                                    (uint8_t)TARGET_DATA_SIZE;
-                                    }
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_DATA_IN;
-                            }
-                            else
-                            {
-#ifdef QL_DEBUG_LEVEL_2
-                                    qla1280_print("qla1280_atio_entry: SM_RDDB, zero length\n\r");
-#endif
-                                    pkt->scsi_status = S_GOOD;
-                                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                                            (uint32_t)OF_NO_DATA;
-                            }
-                            break;
-                        default:
-#ifdef QL_DEBUG_LEVEL_2
-                            qla1280_print("qla1280_atio_entry: SM_RDDB unknown mode\n\r");
-#endif
-                            *sense_ptr = 0x70;
-                            *(sense_ptr+2) = SD_ILLREQ;
-                            *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                            *(sense_ptr+12) = SC_ILLCDB;
-                            len = 0;
-                            pkt->scsi_status = S_CKCON;
-                            pkt->option_flags |= (uint32_t)OF_SSTS |
-                                    (uint32_t)OF_NO_DATA;
-                            break;
-                    }
-                    break;
-                default:
-#ifdef QL_DEBUG_LEVEL_2
-                    qla1280_print("qla1280_atio_entry: Unknown SCSI command\n\r");
-                    qla1280_dump_buffer((caddr_t)&pkt->cdb[0], pkt->cdb_len);
-#endif
-                    bzero(sense_ptr, TARGET_SENSE_SIZE);
-                    *sense_ptr = 0x70;
-                    *(sense_ptr+2) = SD_ILLREQ;
-                    *(sense_ptr+7) = TARGET_SENSE_SIZE-8;
-                    *(sense_ptr+12) = SC_INVOPCODE;
-                    len = 0;
-                    pkt->scsi_status = S_CKCON;
-                    pkt->option_flags |= (uint32_t)OF_SSTS |
-                            (uint32_t)OF_NO_DATA;
-                    break;
-            }
-            if (ha->flags.enable_64bit_addressing)
-                qla1280_64bit_continue_io(ha, pkt, len, (paddr32_t *)&phy_addr);
-            else
-                qla1280_32bit_continue_io(ha, pkt, len, (paddr32_t *)&phy_addr);
-            break;
-        default:
-            break;
-    }
+	uint8_t bus;
 
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_atio_entry: exiting normally\n\r");
-#endif
+	ENTER("qla1280_rst_aen");
+
+	if (ha->flags.online && !ha->flags.reset_active &&
+	    !ha->flags.abort_isp_active) {
+		ha->flags.reset_active = 1;
+		while (ha->flags.reset_marker) {
+			/* Issue marker command. */
+			ha->flags.reset_marker = 0;
+			for (bus = 0; bus < ha->ports &&
+				     !ha->flags.reset_marker; bus++) {
+				if (ha->bus_settings[bus].reset_marker) {
+					ha->bus_settings[bus].reset_marker = 0;
+					qla1280_marker(ha, bus, 0, 0,
+						       MK_SYNC_ALL);
+				}
+			}
+		}
+	}
+
+	LEAVE("qla1280_rst_aen");
 }
 
+
+#if LINUX_VERSION_CODE < 0x020500
 /*
- *  qla1280_notify_entry
- *      Processes received ISP immediate notify entry.
  *
- * Input:
- *      ha  = adapter block pointer.
- *      pkt = entry pointer.
  */
-STATIC void
-qla1280_notify_entry(scsi_qla_host_t *ha, notify_entry_t *pkt)
+static void
+qla1280_get_target_options(struct scsi_cmnd *cmd, struct scsi_qla_host *ha)
 {
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_notify_entry: entered\n\r");
-#endif
+	unsigned char *result;
+	struct nvram *n;
+	int bus, target, lun;
 
-    /* Acknowledge immediate notify */
-    qla1280_notify_ack(ha, pkt);
+	bus = SCSI_BUS_32(cmd);
+	target = SCSI_TCN_32(cmd);
+	lun = SCSI_LUN_32(cmd);
 
-    /* Issue notify entry to increment resource count */
-    qla1280_immed_notify(ha, pkt);
+	/*
+	 * Make sure to not touch anything if someone is using the
+	 * sg interface.
+	 */
+	if (cmd->use_sg || (CMD_RESULT(cmd) >> 16) != DID_OK || lun)
+		return;
 
-#ifdef QL_DEBUG_LEVEL_3
-    qla1280_print("qla1280_notify_entry: exiting normally\n\r");
-#endif
+	result = cmd->request_buffer;
+	n = &ha->nvram;
+
+	n->bus[bus].target[target].parameter.f.enable_wide = 0;
+	n->bus[bus].target[target].parameter.f.enable_sync = 0;
+	n->bus[bus].target[target].ppr_1x160.flags.enable_ppr = 0;
+
+        if (result[7] & 0x60)
+		n->bus[bus].target[target].parameter.f.enable_wide = 1;
+        if (result[7] & 0x10)
+		n->bus[bus].target[target].parameter.f.enable_sync = 1;
+	if ((result[2] >= 3) && (result[4] + 5 > 56) &&
+	    (result[56] & 0x4))
+		n->bus[bus].target[target].ppr_1x160.flags.enable_ppr = 1;
+
+	dprintk(2, "get_target_options(): wide %i, sync %i, ppr %i\n",
+		n->bus[bus].target[target].parameter.f.enable_wide,
+		n->bus[bus].target[target].parameter.f.enable_sync,
+		n->bus[bus].target[target].ppr_1x160.flags.enable_ppr);
 }
+#endif
 
-#endif  /* QLA1280_TARGET_MODE_SUPPORT */
 /*
  *  qla1280_status_entry
  *      Processes received ISP status entry.
